// Generated by zig-wayland

// Copyright 2021 Isaac Freund
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

// This protocol allows for a privileged Wayland client to lock the session
// and display arbitrary graphics while the session is locked.
// 
// The compositor may choose to restrict this protocol to a special client
// launched by the compositor itself or expose it to all privileged clients,
// this is compositor policy.
// 
// The client is responsible for performing authentication and informing the
// compositor when the session should be unlocked. If the client dies while
// the session is locked the session remains locked, possibly permanently
// depending on compositor policy.
// 
// Warning! The protocol described in this file is currently in the
// testing phase. Backward compatible changes may be added together with
// the corresponding interface version bump. Backward incompatible changes
// can only be done by creating a new major version of the extension.
// 

const std = @import("std");
const os = std.os;
const client = @import("wayland.zig").client;
const common = @import("common.zig");pub const SessionLockManagerV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_manager_v1.getInterface;pub fn setQueue(_session_lock_manager_v1: *SessionLockManagerV1, _queue: *client.wl.EventQueue) void {
    const _proxy = @ptrCast(*client.wl.Proxy, _session_lock_manager_v1);
    _proxy.setQueue(_queue);
}pub fn destroy(_session_lock_manager_v1: *SessionLockManagerV1) void {const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_manager_v1);_proxy.marshal(0, null);_proxy.destroy();}
pub fn lock(_session_lock_manager_v1: *SessionLockManagerV1) !*client.ext.SessionLockV1{const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_manager_v1);var _args = [_]common.Argument{.{ .o = null },};
return @ptrCast(*client.ext.SessionLockV1, try _proxy.marshalConstructor(1, &_args, client.ext.SessionLockV1.getInterface()));}
};
pub const SessionLockV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_v1.getInterface;pub const Error = common.ext.session_lock_v1.Error;
pub fn setQueue(_session_lock_v1: *SessionLockV1, _queue: *client.wl.EventQueue) void {
    const _proxy = @ptrCast(*client.wl.Proxy, _session_lock_v1);
    _proxy.setQueue(_queue);
}pub const Event = union(enum) {locked: void,finished: void,};
pub inline fn setListener(
    _session_lock_v1: *SessionLockV1,
    comptime T: type,
    _listener: *const fn (session_lock_v1: *SessionLockV1, event: Event, data: T) void,
    _data: T,
) void {
    const _proxy = @ptrCast(*client.wl.Proxy, _session_lock_v1);
    const _mut_data = @intToPtr(?*anyopaque, @ptrToInt(_data));
    _proxy.addDispatcher(common.Dispatcher(SessionLockV1, T).dispatcher, _listener, _mut_data);
}pub fn destroy(_session_lock_v1: *SessionLockV1) void {const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_v1);_proxy.marshal(0, null);_proxy.destroy();}
pub fn getLockSurface(_session_lock_v1: *SessionLockV1, _surface:*client.wl.Surface, _output:*client.wl.Output) !*client.ext.SessionLockSurfaceV1{const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_v1);var _args = [_]common.Argument{.{ .o = null },.{ .o = @ptrCast(*common.Object, _surface) },.{ .o = @ptrCast(*common.Object, _output) },};
return @ptrCast(*client.ext.SessionLockSurfaceV1, try _proxy.marshalConstructor(1, &_args, client.ext.SessionLockSurfaceV1.getInterface()));}
pub fn unlockAndDestroy(_session_lock_v1: *SessionLockV1) void {const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_v1);_proxy.marshal(2, null);_proxy.destroy();}
};
pub const SessionLockSurfaceV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_surface_v1.getInterface;pub const Error = common.ext.session_lock_surface_v1.Error;
pub fn setQueue(_session_lock_surface_v1: *SessionLockSurfaceV1, _queue: *client.wl.EventQueue) void {
    const _proxy = @ptrCast(*client.wl.Proxy, _session_lock_surface_v1);
    _proxy.setQueue(_queue);
}pub const Event = union(enum) {configure: struct {serial:u32,width:u32,height:u32,},
};
pub inline fn setListener(
    _session_lock_surface_v1: *SessionLockSurfaceV1,
    comptime T: type,
    _listener: *const fn (session_lock_surface_v1: *SessionLockSurfaceV1, event: Event, data: T) void,
    _data: T,
) void {
    const _proxy = @ptrCast(*client.wl.Proxy, _session_lock_surface_v1);
    const _mut_data = @intToPtr(?*anyopaque, @ptrToInt(_data));
    _proxy.addDispatcher(common.Dispatcher(SessionLockSurfaceV1, T).dispatcher, _listener, _mut_data);
}pub fn destroy(_session_lock_surface_v1: *SessionLockSurfaceV1) void {const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_surface_v1);_proxy.marshal(0, null);_proxy.destroy();}
pub fn ackConfigure(_session_lock_surface_v1: *SessionLockSurfaceV1, _serial:u32) void {const _proxy = @ptrCast(*client.wl.Proxy,_session_lock_surface_v1);var _args = [_]common.Argument{.{ .u = _serial},};
_proxy.marshal(1, &_args);}
};
